package com.xhpc.user.mapper;

import com.xhpc.system.api.domain.SysRole;
import com.xhpc.system.api.domain.SysUser;
import com.xhpc.user.domain.SysUserRole;
import org.apache.ibatis.annotations.Param;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * 用户信息 数据层
 *
 * @author ruoyi
 */
public interface XhpcUserMapper {

    /**
     * 修改用户信息
     *
     * @param sysUser 用户信息
     * @return 结果
     */
    public int update(SysUser sysUser);

    /**
     * 批量删除用户信息
     *
     * @param ids 需要删除的数据ID
     * @return 结果
     */
    public int deleteByIds(Long[] ids);

    /**
     * 查询用户信息
     *
     * @param userId 用户id
     * @return 结果
     */
    public SysUser selectUserByUserId(@Param("userId") Long userId);

    /**
     * 获取平台用户分页列表
     *
     * @param userName 用户账号
     * @param nickName 用户昵称
     * @return 结果
     */
    public List<Map<String, Object>> selectPcUserList(@Param("userName") String userName, @Param("nickName") String nickName,@Param("tenantId")String tenantId);

    /**
     * 平台用户详情
     *
     * @param userId 用户id
     * @return 结果
     */
    public Map<String, Object> pcInfo(@Param("userId") Long userId);

    /**
     * 获取运营商用户分页列表
     *
     * @param userName 用户账号
     * @param nickName 用户昵称
     * @return 结果
     */
    public List<Map<String, Object>> selectOperatorUserList(@Param("userName") String userName, @Param("nickName") String nickName, @Param("operatorId") Long operatorId,@Param("userrType")String userrType,@Param("tenantId")String tenantId);

    /**
     * 运营商用户详情
     *
     * @param userId 用户id
     * @return 结果
     */
    public Map<String, Object> operatorInfo(@Param("userId") Long userId);

    /**
     * 通过用户账号查询用户详情
     *
     * @param userName 用户账号
     * @return 结果
     */
    public SysUser selectUserByUserName(@Param("userName") String userName);

    /**
     * 通过创建账号查询用户子账号
     *
     * @param createBy 用户账号
     * @return 结果
     */
    public List<SysUser> selectUserByCreateBy(@Param("createBy") String createBy);

    /**
     * 通过用户账号查询用户详情
     *
     * @param userName 用户账号
     * @return 结果
     */
    public SysRole selectUserByRoleName(@Param("userName") String userName);


    /**
     * 新增角色信息
     *
     * @param role 角色信息
     * @return 结果
     */
    public int insertRole(SysRole role);

    /**
     * 新增用户信息
     *
     * @param user 用户信息
     * @return 结果
     */
    public int insertUser(SysUser user);

    /**
     * 批量新增用户角色信息
     *
     * @param userRoleList 用户角色列表
     * @return 结果
     */
    public int batchUserRole(List<SysUserRole> userRoleList);

    /**
     * 校验用户名称是否唯一
     *
     * @param userName 用户名称
     * @return 结果
     */
    public int checkUserNameUnique(@Param("userName")String userName,@Param("userId")Long userId);


    /**
     * 保存数据维度
     * @param userId
     * @param chargingStationId
     */
    public void addXhpcDataDimension(@Param("userId")Long userId,@Param("chargingStationId")Long chargingStationId);


    /**
     * 删除数据维度
     * @param userId
     */
    public void updateXhpcDataDimension(@Param("userId")Long userId);


    public int getOrderTimeNumber(@Param("userId")String userId,@Param("startTime")String startTime,@Param("endTime")String endTime,@Param("tenantId")String tenantId);

    List<Map<String,Object>> getUserDimension(@Param("userId")String userId,@Param("startTime")String startTime,@Param("endTime")String endTime,@Param("tenantId")String tenantId,@Param("activity")Integer activity,@Param("frequency")Integer frequency,@Param("amount") BigDecimal amount,@Param("phone")String phone);


    /**
     * 修改流量方用户信息
     *
     * @param sysUser 用户信息
     * @return 结果
     */
    public int updateInternetUser(SysUser sysUser);
}
